require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_X86_64_PGTABLE_H)) {
    eval 'sub _X86_64_PGTABLE_H () {1;}' unless defined(&_X86_64_PGTABLE_H);
    unless(defined(&__ASSEMBLY__)) {
	require 'asm/processor.ph';
	require 'asm/fixmap.ph';
	require 'asm/bitops.ph';
	require 'asm/pda.ph';
	require 'linux/threads.ph';
	require 'linux/config.ph';
	eval 'sub swapper_pg_dir () { &NULL;}' unless defined(&swapper_pg_dir);
	eval 'sub flush_cache_all () {
	    eval q( &do { }  &while (0));
	}' unless defined(&flush_cache_all);
	eval 'sub flush_cache_mm {
	    local($mm) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&flush_cache_mm);
	eval 'sub flush_cache_range {
	    local($mm, $start, $end) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&flush_cache_range);
	eval 'sub flush_cache_page {
	    local($vma, $vmaddr) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&flush_cache_page);
	eval 'sub flush_page_to_ram {
	    local($page) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&flush_page_to_ram);
	eval 'sub flush_dcache_page {
	    local($page) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&flush_dcache_page);
	eval 'sub flush_icache_range {
	    local($start, $end) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&flush_icache_range);
	eval 'sub flush_icache_page {
	    local($vma,$pg) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&flush_icache_page);
	eval 'sub flush_icache_user_range {
	    local($vma,$pg,$adr,$len) = @_;
    	    eval q( &do { }  &while (0));
	}' unless defined(&flush_icache_user_range);
	eval 'sub __flush_tlb () {
	    eval q( &do { \'unsigned long tmpreg\';  &__asm__  &__volatile__( \\"movq %%cr3, %0;  # flush TLB \\\\n\\" \\"movq %0, %%cr3;	      \\\\n\\" : \\"=r\\" ( &tmpreg) :: \\"memory\\"); }  &while (0));
	}' unless defined(&__flush_tlb);
	eval 'sub __flush_tlb_global () {
	    eval q( &do { \'unsigned long tmpreg\';  &__asm__  &__volatile__( \\"movq %1, %%cr4;  # turn off PGE     \\\\n\\" \\"movq %%cr3, %0;  # flush TLB	\\\\n\\" \\"movq %0, %%cr3;		     \\\\n\\" \\"movq %2, %%cr4;  # turn PGE back on \\\\n\\" : \\"=&r\\" : \\"r\\" ( &mmu_cr4_features & ~ &X86_CR4_PGE), \\"r\\" ( &mmu_cr4_features) : \\"memory\\"); }  &while (0));
	}' unless defined(&__flush_tlb_global);
	eval 'sub __flush_tlb_all () {
	    eval q( &__flush_tlb_global());
	}' unless defined(&__flush_tlb_all);
	eval 'sub __flush_tlb_one {
	    local($addr) = @_;
    	    eval q( &__asm__  &__volatile__(\\"invlpg %0\\": :\\"m\\" (* $addr)));
	}' unless defined(&__flush_tlb_one);
	eval 'sub ZERO_PAGE {
	    local($vaddr) = @_;
    	    eval q(( &virt_to_page( &empty_zero_page)));
	}' unless defined(&ZERO_PAGE);
    }
    eval 'sub PML4_SHIFT () {39;}' unless defined(&PML4_SHIFT);
    eval 'sub PTRS_PER_PML4 () {512;}' unless defined(&PTRS_PER_PML4);
    eval 'sub PGDIR_SHIFT () {30;}' unless defined(&PGDIR_SHIFT);
    eval 'sub PTRS_PER_PGD () {512;}' unless defined(&PTRS_PER_PGD);
    eval 'sub PMD_SHIFT () {21;}' unless defined(&PMD_SHIFT);
    eval 'sub PTRS_PER_PMD () {512;}' unless defined(&PTRS_PER_PMD);
    eval 'sub PTRS_PER_PTE () {512;}' unless defined(&PTRS_PER_PTE);
    eval 'sub pte_ERROR {
        local($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pte %p(%016lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e),  &pte_val($e)));
    }' unless defined(&pte_ERROR);
    eval 'sub pmd_ERROR {
        local($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pmd %p(%016lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e),  &pmd_val($e)));
    }' unless defined(&pmd_ERROR);
    eval 'sub pgd_ERROR {
        local($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pgd %p(%016lx).\\\\n\\",  &__FILE__,  &__LINE__, ($e),  &pgd_val($e)));
    }' unless defined(&pgd_ERROR);
    eval 'sub pml4_none {
        local($x) = @_;
	    eval q((! &pml4_val($x)));
    }' unless defined(&pml4_none);
    eval 'sub pgd_none {
        local($x) = @_;
	    eval q((! &pgd_val($x)));
    }' unless defined(&pgd_none);
1;
